' *** SeroutToLCDdata.bas ****************************** 2011.10.01 ***

' This program demonstrates the use of the DATA command
' to send data to be displayed on the upgraded 16x2 LCD.

' Note: see this month's Primer article for detailed explanations
'       of the comments that are numbered [1] through [4]

' *** Constants ****
  symbol txPin = B.4                   'serial output pin to LCD

' *** Variables ****
  symbol chout =  b0                   'used in for/next loop (print)
  symbol index =  b1                   'used in for/next loop (main)

' *** Directives ***
  #com 6
  #picaxe 14M2
  #terminal off
  
' Once the data has been downloaded to the processor, the following
' directive can be "un-commented" to save time in subsequent downloads.

' #no_data                                                          [1]

' Please forgive my misspelling of "blood" in the following data.
' I wanted everyting to fit on our 16x2 LCD! :-)

' *** Data ***********************
  data  0,(128,"And then he said")     'In this case, it's OK       [2]
  data 17,(192,"Fee, Fi, Fo, Fum")     'to start with loc 0. 
  data 34,(128,"I smell the blud")
  data 51,(192,"of an Englishman")
  data 68,(0)
  
' The final data statement never gets accessed, I just include it to
' remind myself that the last "real" data byte ("n") is at location 67.
		
' *** Begin Main Program **********************************************

  setfreq m8
  wait 6                               'give LCD time to initialize

  for index = 0 to 67                  'Copy data from EEPROM       [3]
    bptr = index + 28                  'to the storage area,
    read index,@bptr
  next index
 
do
  for index = 0 to 67 step 17          'index = 0, 17, 34, & 51     [4]
    bptr = index + 28                  'Set bptr to first char in line.
    if @bptr = 128 then gosub clearLCD 'If it's 128 then clear the LCD.
    gosub print                        'Print the line to the LCD
  next index
loop

' *** End Main Program - Subroutines Follow ***************************

clearLCD:
  serout txPin,N9600_8,(1)             'Command 1: Clear the LCD screen
  wait 4
  return 

print:
  for chout = 1 to 17
    serout txPin,N9600_8,(@bptrinc)
  next chout
  wait 4
  return