' *** SeroutToLCDdemo.bas ***************************** 2011.10.01 ***

' This program sends variable length serial data to the LCD to
' demonstrate the advantages of the upgraded 14M2 driver software.

' Note: To allow the LCD enough time to display the incoming data,
' a pause is required between any two consecutive serout commands.
' At 8MHz, "pause 400" works well. If your program is running at
' a higher speed, increase the value of "abit" proportionally.

' Also, the receiving program allows 41 chars max, which is more
' more than enough for a 16X2 LCD. If you use a larger display,
' you can modify the LCD driver software to accept longer strings.

' Note: see this month's Primer article for detailed explanations
'       of the comments that are numbered [1] through [6]

' *** Constants ****
  symbol  abit = 400              ' minimum pause at 8MHz
  symbol txPin = B.4              ' serial output pin to LCD
	
' *** Variables ****
  symbol index =  b0              ' used in for/next loop

' *** Directives ***
  #com 6
  #picaxe 14M2
  #no_data
  #terminal off

' *** Begin Main Program *********************************************
  setfreq m8
  wait 6                          ' give LCD time to display "ready"
  
do
  serout txPin,N9600_8,(1)        ' clear the display
  pause abit                      ' don't forget to pause

' This command fills line 1 of the display.                        [1]
  serout txPin,N9600_8,(128," Now you see it.")
  wait 4                          ' allow time to read display

' This command updates one word on line 1, starting at loc 137     [2]
  serout txPin,N9600_8,(137,"don't! ")
  wait 4                          ' allow time to read display
	
' This command fills both lines of the display                     [3]
  serout txPin,N9600_8,(128,"Three jolly pigs",192,"are so annoying!")
  wait 4                          ' allow time to read display

' This command updates part of line 1, and part of line 2.         [4]
  serout txPin,N9600_8,(128,"Seven",196,"even worse!!")
  wait 4                          ' allow time to read display
	
' This command again fills both lines, and sums it up!             [5]
  serout txPin,N9600_8,(128,"As you can see, ",192,"it's very easy! ")
  wait 4
  	
' And this loop is our grand finale - it "blinks" the word "very"  [6]
  for index = 1 to 4
    pause abit
    serout txPin,N9600_8,(197,"    ")
    pause abit
    serout txPin,N9600_8,(197,"very")
    pause abit
  next index
  
  wait 4                          ' allow time to read display
loop