' *** SeroutToLCDtable.bas ***************************** 2011.10.01 ***

' This program demonstrates the use of the TABLE and TABLECOPY
' commands to send data to be displayed on the upgraded 16x2 LCD.

' Note: see this month's Primer article for detailed explanations
'       of the comments that are numbered [1] through [3]

' *** Constants ****
  symbol txPin = B.4                   'serial output pin to LCD

' *** Variables ****
  symbol chout =  b0                   'used in for/next loop (print)
  symbol index =  b1                   'used in for/next loop (main)

' *** Directives ***
  #com 6
  #picaxe 14M2
  #no_data
  #terminal off

' Please forgive my misspelling of "blood" in the following table.
' I wanted everyting to fit on our 16x2 LCD! :-)

' *** Table ***********************                                 [1]
  table 28,(128,"And then he said")    'We're starting our table
  table 45,(192,"Fee, Fi, Fo, Fum")    'at location 28 to avoid
  table 62,(128,"I smell the blud")    'any possible conflicts
  table 79,(192,"of an Englishman")    'with the GP variables.
  table 96,(0,0)
  
' The final table statement never gets accessed, I just include it to
' remind myself that the last "real" data byte ("n") is at location 95.
			
' *** Begin Main Program **********************************************

  setfreq m8
  wait 6                               'give LCD time to initialize
  
  tablecopy 28,95
  
do                     
  for index = 28 to 95 step 17         'index = 28, 45, 62, & 79   [2]
    bptr = index                       'Set bptr to first char in line.
    if @bptr = 128 then gosub clearLCD 'If it's 128 then clear the LCD,
    gosub print                        'and print the line.
  next index
loop

' *** End Main Program - Subroutines Follow ***************************

clearLCD:
  serout txPin,N9600_8,(1)             'Command 1: Clear the LCD screen
  wait 4
  return 

print:
  for chout = 1 to 17                  '                            [3]
    serout txPin,N9600_8,(@bptrinc)
  next chout
  wait 4
  return